//map

//f1: one-to-one function
//f2: one-to-many function

//list.map(f1) => list of elements
//list.map(f2) => list of list

val numbers = listOf(1, 2, 3)

println(numbers.map { e -> e + 1 }) //list => list
println(numbers.map { e -> listOf(e - 1, e + 1)})
  //list => list of list
  
//what if you have one-to-many function,
//but you don't want a list of list, but just a 
//single list

println(
  numbers.map { e -> listOf(e - 1, e + 1 )}.flatten())
  
//if you have many-to-many function, but you want
//a list and not a list-of-list as output, then
//use flatMap

println(
  numbers.flatMap { e -> listOf(e - 1, e + 1 )})
  


  
  
  
  